/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.OctetsStream
 *  fire.msp.GGetRolesByConditions
 *  fire.msp.IGetRolesCallBack
 *  fire.msp.role.GSendAroundExceptMe
 *  fire.pb.GsClient
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.GetRolesCallBackInst
 *  xbean.Pod
 *  xtable.Getrolescallback
 */
package fire.pb.map;

import com.locojoy.base.Marshal.OctetsStream;
import fire.msp.GGetRolesByConditions;
import fire.msp.IGetRolesCallBack;
import fire.msp.role.GSendAroundExceptMe;
import fire.pb.GsClient;
import fire.pb.map.Position;
import fire.pb.map.Role;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.GetRolesCallBackInst;
import xbean.Pod;
import xtable.Getrolescallback;

public class RoleManager {
    private static final RoleManager instance = new RoleManager();
    private Map<Long, Role> roles = new ConcurrentHashMap<Long, Role>();

    public static RoleManager getInstance() {
        return instance;
    }

    private RoleManager() {
    }

    public Map<Long, Role> getRoles() {
        return this.roles;
    }

    public Role getRoleByID(long roleID) {
        return this.roles.get(roleID);
    }

    public Role removeRoleByID(long roleID) {
        return this.roles.remove(roleID);
    }

    public Role createRole(long roleID, long sceneId, int posx, int posy) {
        Role role = this.roles.get(roleID);
        if (role != null) {
            return role;
        }
        role = new Role(roleID);
        role.setScene(sceneId);
        role.setPos(new Position(posx, posy));
        this.roles.put(roleID, role);
        return role;
    }

    public static void sendAroundExceptMe(long roleId, Protocol p2) {
        GSendAroundExceptMe gSendAroundExceptMe = new GSendAroundExceptMe();
        gSendAroundExceptMe.roleid = roleId;
        gSendAroundExceptMe.protype = p2.getType();
        gSendAroundExceptMe.protocol = p2.marshal(new OctetsStream());
        GsClient.sendToScene((Protocol)gSendAroundExceptMe);
    }

    public static void psendAroundExceptMeWhileCommit(long roleId, Protocol p2) {
        GSendAroundExceptMe gSendAroundExceptMe = new GSendAroundExceptMe();
        gSendAroundExceptMe.roleid = roleId;
        gSendAroundExceptMe.protype = p2.getType();
        gSendAroundExceptMe.protocol = p2.marshal(new OctetsStream());
        GsClient.pSendWhileCommit((Protocol)gSendAroundExceptMe);
    }

    public static void getRolesByConditions(int schoolId, int minlevel, int maxlevel, long sceneId, int limitnum, IGetRolesCallBack callback) {
        if (Transaction.current() != null) {
            new PGetRolesByConditions(schoolId, minlevel, maxlevel, sceneId, limitnum, callback).call();
        } else {
            new PGetRolesByConditions(schoolId, minlevel, maxlevel, sceneId, limitnum, callback).submit();
        }
    }

    static class PGetRolesByConditions
    extends Procedure {
        private IGetRolesCallBack callback;
        private int schoolid;
        private int minlevel;
        private int maxlevel;
        private long sceneid;
        private int limitnum;

        public PGetRolesByConditions(int schoolid, int minlevel, int maxlevel, long sceneid, int limitnum, IGetRolesCallBack callback) {
            this.callback = callback;
            this.schoolid = schoolid;
            this.minlevel = minlevel;
            this.maxlevel = maxlevel;
            this.sceneid = sceneid;
            this.limitnum = limitnum;
        }

        protected boolean process() {
            if (this.callback == null) {
                return true;
            }
            GetRolesCallBackInst callbackbean = Pod.newGetRolesCallBackInst();
            callbackbean.setCallback(this.callback);
            long callbackId = Getrolescallback.insert((GetRolesCallBackInst)callbackbean);
            GGetRolesByConditions getroles = new GGetRolesByConditions(callbackId, this.schoolid, this.minlevel, this.maxlevel, this.sceneid, this.limitnum);
            GsClient.sendToScene((Protocol)getroles);
            return true;
        }
    }
}

